You can not select more than 25 topics
Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
89 lines
2.4 KiB
89 lines
2.4 KiB
5 years ago
|
diff --git a/tests/Makefile.am b/tests/Makefile.am
|
||
|
index bafb12ae0..d249d405f 100644
|
||
|
--- a/tests/Makefile.am
|
||
|
+++ b/tests/Makefile.am
|
||
|
@@ -156,7 +156,7 @@ endif
|
||
|
endif
|
||
|
|
||
|
check_PROGRAMS = $(ctests)
|
||
|
-dist_check_SCRIPTS = rfc2253-escape-test
|
||
|
+dist_check_SCRIPTS = rfc2253-escape-test sni-hostname.sh
|
||
|
|
||
|
TESTS = $(ctests) $(dist_check_SCRIPTS)
|
||
|
|
||
|
diff --git a/tests/sni-hostname.sh b/tests/sni-hostname.sh
|
||
|
new file mode 100755
|
||
|
index 000000000..4fb51be68
|
||
|
--- /dev/null
|
||
|
+++ b/tests/sni-hostname.sh
|
||
|
@@ -0,0 +1,66 @@
|
||
|
+#!/bin/sh
|
||
|
+
|
||
|
+# Copyright (C) 2017 Nikos Mavrogiannopoulos
|
||
|
+#
|
||
|
+# Author: Nikos Mavrogiannopoulos
|
||
|
+#
|
||
|
+# This file is part of GnuTLS.
|
||
|
+#
|
||
|
+# GnuTLS is free software; you can redistribute it and/or modify it
|
||
|
+# under the terms of the GNU General Public License as published by the
|
||
|
+# Free Software Foundation; either version 3 of the License, or (at
|
||
|
+# your option) any later version.
|
||
|
+#
|
||
|
+# GnuTLS is distributed in the hope that it will be useful, but
|
||
|
+# WITHOUT ANY WARRANTY; without even the implied warranty of
|
||
|
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
|
||
|
+# General Public License for more details.
|
||
|
+#
|
||
|
+# You should have received a copy of the GNU General Public License
|
||
|
+# along with GnuTLS; if not, write to the Free Software Foundation,
|
||
|
+# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
|
||
|
+
|
||
|
+srcdir="${srcdir:-.}"
|
||
|
+SERV="${SERV:-../src/gnutls-serv${EXEEXT}}"
|
||
|
+CLI="${CLI:-../src/gnutls-cli${EXEEXT}}"
|
||
|
+unset RETCODE
|
||
|
+
|
||
|
+if ! test -x "${SERV}"; then
|
||
|
+ exit 77
|
||
|
+fi
|
||
|
+
|
||
|
+if ! test -x "${CLI}"; then
|
||
|
+ exit 77
|
||
|
+fi
|
||
|
+
|
||
|
+if test "${WINDIR}" != ""; then
|
||
|
+ exit 77
|
||
|
+fi
|
||
|
+
|
||
|
+if ! test -z "${VALGRIND}"; then
|
||
|
+ VALGRIND="${LIBTOOL:-libtool} --mode=execute ${VALGRIND} --error-exitcode=15"
|
||
|
+fi
|
||
|
+
|
||
|
+
|
||
|
+SERV="${SERV} -q"
|
||
|
+
|
||
|
+. "${srcdir}/scripts/common.sh"
|
||
|
+
|
||
|
+echo "Checking SNI hostname in gnutls-cli"
|
||
|
+
|
||
|
+eval "${GETPORT}"
|
||
|
+launch_server $$ --echo --priority "NORMAL:+ANON-ECDH" --sni-hostname-fatal --sni-hostname example.com
|
||
|
+PID=$!
|
||
|
+wait_server ${PID}
|
||
|
+
|
||
|
+${VALGRIND} "${CLI}" -p "${PORT}" 127.0.0.1 --sni-hostname example.com --priority "NORMAL:+ANON-ECDH:+ANON-DH" </dev/null >/dev/null || \
|
||
|
+ fail ${PID} "1. rehandshake should have succeeded!"
|
||
|
+
|
||
|
+${VALGRIND} "${CLI}" -p "${PORT}" 127.0.0.1 --sni-hostname noexample.com --priority "NORMAL:+ANON-ECDH:+ANON-DH" </dev/null >/dev/null && \
|
||
|
+ fail ${PID} "2. rehandshake should have failed!"
|
||
|
+
|
||
|
+
|
||
|
+kill ${PID}
|
||
|
+wait
|
||
|
+
|
||
|
+exit 0
|
||
|
--
|
||
|
2.14.3
|
||
|
|